#ifndef id73F121AEE1EB4BA0980FAC025E5CDF05
#define id73F121AEE1EB4BA0980FAC025E5CDF05

#include "doorkeeper/components/tileiterator.hpp"
#include "doorkeeper/implem/maptypes.hpp"
#include <cstdint>
#include <ciso646>

namespace dk {
	//MapType_IsometricStaggered,
	//MapType_Isometric,
	//MapType_Orthogonal,
	//MapType_Hex
	template <uint32_t D>
	class PixelConv {
	public:
		typedef Vector<D> coords;

		explicit PixelConv ( MapTypes parType );

		virtual coords to_pixel ( const coords& parFrom, const coords& parSize ) const = 0;
		MapTypes map_type ( void ) const;

	private:
		const MapTypes m_map_type;
	};

	template <uint32_t D>
	class PixelConvSquare : public PixelConv<D> {
	public:
		using base_class = PixelConv<D>;
		using typename base_class::coords;

		PixelConvSquare ( void );
		virtual ~PixelConvSquare ( void ) noexcept = default;

		virtual coords to_pixel ( const coords& parFrom, const coords& parSize ) const;
	};

	class PixelConvDiamond : public PixelConv<2> {
	public:
		using base_class = PixelConv<2>;
		using base_class::coords;

		PixelConvDiamond ( bool parStaggered, bool parFirstReentrant );
		PixelConvDiamond ( bool parStaggered, bool parFirstReentrant, const coords& parRatio );
		virtual ~PixelConvDiamond ( void ) noexcept = default;

		virtual coords to_pixel ( const coords& parFrom, const coords& parSize ) const;

	protected:
		const coords m_ratio;
		const CoordinateScalarType m_first_reentr;
		const bool m_staggered;
	};

	class PixelConvHex : public PixelConv<2> {
	public:
		using base_class = PixelConv<2>;
		using base_class::coords;

		explicit PixelConvHex ( bool parFirstReentrant );
		virtual ~PixelConvHex ( void ) noexcept = default;

		virtual coords to_pixel ( const coords& parFrom, const coords& parSize ) const;
	};

	template <typename T, typename T1>
	Vector<2> get_diamond_coordinates ( const TileIterator<T, 2, T1>& parIterator, const Vector<2>& parSize ) a_pure a_deprecated;

	template <typename T, typename T1>
	Vector<2> get_half_diamond_coordinates ( const TileIterator<T, 2, T1>& parIterator, const Vector<2>& parSize ) a_pure a_deprecated;

	template <uint32_t D, typename T, typename T1>
	Vector<D> get_square_coordinates ( const TileIterator<T, D, T1>& parIterator, const Vector<D>& parSize ) a_pure a_deprecated;

	template <typename T, typename T1>
	Vector<2> get_hex_coordinates ( const TileIterator<T, 2, T1>& parIterator, const Vector<2>& parSize ) a_pure a_deprecated;
} //namespace dk

#include "doorkeeper/implem/pixelconv.inl"

#endif
